package com.zt.task;

import com.zt.commons.KafkaMessage;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.UUID;

@Component
public class KafkaMessageProducer {
    private final KafkaTemplate<String, KafkaMessage> kafkaTemplate;
    private static final String TOPIC = "test-topic";

    public KafkaMessageProducer(KafkaTemplate<String, KafkaMessage> kafkaTemplate) {
        this.kafkaTemplate = kafkaTemplate;
    }
    @Scheduled(fixedRate = 60000)
    public void sendMessage(){
        String msgId = UUID.randomUUID().toString();
        KafkaMessage message=new KafkaMessage(msgId,"scheduled_msg","定时消息内容，时间: " + System.currentTimeMillis());
        kafkaTemplate.send(TOPIC,message);
        System.out.println("发送消息: " + message);
    }
}
